'use strict';

define(['app'], function(app) {
	app.controller("initialSettings105",
		["$rootScope", "$scope", "api", "util", "alert",
			function ($rootScope, $scope, api, util, alert) {

				var name = 'initialSettings';
				var order = 105;

				var feature = {
					_id: order + "_" + name,
					feature: name,
					order: order,
				};

				$scope.saveData = {
					general: {},
					performance: {},
					resource: {}
				};

				$scope.general = {};
				$scope.performance = {};
				$scope.resource = {};

				api.getSettings({
					data: { section: 'general' },
					success: function (data) {
						$scope.saveData.general = data;
						$scope.general = util.duplicateObject($scope.saveData.general);
					}
				});

				api.getSettings({
					data: { section: 'performance' },
					success: function (data) {
						$scope.saveData.performance = data;
						$scope.performance = util.duplicateObject($scope.saveData.performance);
					}
				});

				api.getSettings({
					data: { section: 'resource' },
					success: function (data) {
						$scope.saveData.resource = data;
						$scope.resource = util.duplicateObject($scope.saveData.resource);
					}
				});

				$scope.$on('save', function () {

					var general = util.saveParams($scope.saveData.general, $scope.general);
					general.section = 'general';

					var performance = util.saveParams($scope.saveData.performance, $scope.performance);
					performance.section = 'performance';

					var resource = util.saveParams($scope.saveData.resource, $scope.resource);
					resource.section = 'resource';

					api.manageSettings({
						data: general,
						success: function () {

							api.manageSettings({
								data: performance,
								success: function () {

									api.manageSettings({
										data: resource,
										success: function () {
											$rootScope.$emit("approve", feature);
										},
										failed: function (message) {
											alert.error(message);
										}
									});

								},
								failed: function (message) {
									alert.error(message);
								}
							});

						},
						failed: function (message) {
							alert.error(message);
						}
					});

				});
			}
		]
	);
});